Index: /branches/2013/dev_r3987_METO1_MERCATOR6_OBC_BDY_merge/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90
===================================================================
--- /branches/2013/dev_r3987_METO1_MERCATOR6_OBC_BDY_merge/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3990)
+++ /branches/2013/dev_r3987_METO1_MERCATOR6_OBC_BDY_merge/NEMOGCM/NEMO/OPA_SRC/BDY/bdydta.F90	(revision 3991)
@@ -80,4 +80,5 @@
       INTEGER,          DIMENSION(jpbgrd) ::   ilen1 
       INTEGER, POINTER, DIMENSION(:)      ::   nblen, nblenrim  ! short cuts
+      TYPE(OBC_DATA), POINTER             ::   dta              ! short cut
       !!
       !!---------------------------------------------------------------------------
@@ -91,15 +92,14 @@
          ! Calculate depth-mean currents
          !-----------------------------
-         CALL wrk_alloc(jpi,jpj,pu2d,pv2d) 
-
-         pu2d(:,:) = 0.e0
-         pv2d(:,:) = 0.e0
-
+         CALL wrk_alloc(jpi,jpj,pun2d,pvn2d) 
+
+         pun2d(:,:) = 0.e0
+         pvn2d(:,:) = 0.e0
          DO ik = 1, jpkm1   !! Vertically integrated momentum trends
-             pu2d(:,:) = pu2d(:,:) + fse3u(:,:,ik) * umask(:,:,ik) * un(:,:,ik)
-             pv2d(:,:) = pv2d(:,:) + fse3v(:,:,ik) * vmask(:,:,ik) * vn(:,:,ik)
+             pun2d(:,:) = pun2d(:,:) + fse3u(:,:,ik) * umask(:,:,ik) * un(:,:,ik)
+             pvn2d(:,:) = pvn2d(:,:) + fse3v(:,:,ik) * vmask(:,:,ik) * vn(:,:,ik)
          END DO
-         pu2d(:,:) = pu2d(:,:) * hur(:,:)
-         pv2d(:,:) = pv2d(:,:) * hvr(:,:)
+         pun2d(:,:) = pun2d(:,:) * hur(:,:)
+         pvn2d(:,:) = pvn2d(:,:) * hvr(:,:)
          
          DO ib_bdy = 1, nb_bdy
@@ -107,71 +107,109 @@
             nblen => idx_bdy(ib_bdy)%nblen
             nblenrim => idx_bdy(ib_bdy)%nblenrim
-
-            IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .eq. 0 ) THEN 
+            dta => dta_bdy(ib_bdy)
+
+            IF( nn_dyn2d_dta(ib_bdy) .eq. 0 ) THEN 
                ilen1(:) = nblen(:)
-               igrd = 1
-               DO ib = 1, ilen1(igrd)
-                  ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                  ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  dta_bdy(ib_bdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)         
-               END DO 
-               igrd = 2
-               DO ib = 1, ilen1(igrd)
-                  ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                  ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  dta_bdy(ib_bdy)%u2d(ib) = pu2d(ii,ij) * umask(ii,ij,1)         
-               END DO 
-               igrd = 3
-               DO ib = 1, ilen1(igrd)
-                  ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                  ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  dta_bdy(ib_bdy)%v2d(ib) = pv2d(ii,ij) * vmask(ii,ij,1)         
-               END DO 
-            ENDIF
-
-            IF( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 0 ) THEN 
-               ilen1(:) = nblen(:)
-               igrd = 2 
-               DO ib = 1, ilen1(igrd)
-                  DO ik = 1, jpkm1
+               IF( dta%ll_ssh ) THEN 
+                  igrd = 1
+                  DO ib = 1, ilen1(igrd)
                      ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                      ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%u3d(ib,ik) =  ( un(ii,ij,ik) - pu2d(ii,ij) ) * umask(ii,ij,ik)         
-                  END DO
-               END DO 
-               igrd = 3 
-               DO ib = 1, ilen1(igrd)
-                  DO ik = 1, jpkm1
+                     dta_bdy(ib_bdy)%ssh(ib) = sshn(ii,ij) * tmask(ii,ij,1)         
+                  END DO 
+               END IF
+               IF( dta%ll_u2d ) THEN 
+                  igrd = 2
+                  DO ib = 1, ilen1(igrd)
                      ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                      ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%v3d(ib,ik) =  ( vn(ii,ij,ik) - pv2d(ii,ij) ) * vmask(ii,ij,ik)         
-                     END DO
-               END DO 
-            ENDIF
-
-            IF( nn_tra(ib_bdy) .gt. 0 .and. nn_tra_dta(ib_bdy) .eq. 0 ) THEN 
-               ilen1(:) = nblen(:)
-               igrd = 1                       ! Everything is at T-points here
-               DO ib = 1, ilen1(igrd)
-                  DO ik = 1, jpkm1
+                     dta_bdy(ib_bdy)%u2d(ib) = pun2d(ii,ij) * umask(ii,ij,1)         
+                  END DO 
+               END IF
+               IF( dta%ll_v2d ) THEN 
+                  igrd = 3
+                  DO ib = 1, ilen1(igrd)
                      ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
                      ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%tem(ib,ik) = tsn(ii,ij,ik,jp_tem) * tmask(ii,ij,ik)         
-                     dta_bdy(ib_bdy)%sal(ib,ik) = tsn(ii,ij,ik,jp_sal) * tmask(ii,ij,ik)         
-                  END DO
-               END DO 
-            ENDIF
-
-#if defined key_lim2
-            IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN 
+                     dta_bdy(ib_bdy)%v2d(ib) = pvn2d(ii,ij) * vmask(ii,ij,1)         
+                  END DO 
+               END IF
+            ENDIF
+
+            IF( nn_dyn3d_dta(ib_bdy) .eq. 0 ) THEN 
                ilen1(:) = nblen(:)
-               igrd = 1                       ! Everything is at T-points here
-               DO ib = 1, ilen1(igrd)
-                  ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
-                  ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                  dta_bdy(ib_bdy)%frld(ib) = frld(ii,ij) * tmask(ii,ij,1)         
-                  dta_bdy(ib_bdy)%hicif(ib) = hicif(ii,ij) * tmask(ii,ij,1)         
-                  dta_bdy(ib_bdy)%hsnif(ib) = hsnif(ii,ij) * tmask(ii,ij,1)         
-               END DO 
+               IF( dta%ll_u3d ) THEN 
+                  igrd = 2 
+                  DO ib = 1, ilen1(igrd)
+                     DO ik = 1, jpkm1
+                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                        dta_bdy(ib_bdy)%u3d(ib,ik) =  ( un(ii,ij,ik) - pun2d(ii,ij) ) * umask(ii,ij,ik)         
+                     END DO
+                  END DO 
+               END IF
+               IF( dta%ll_v3d ) THEN 
+                  igrd = 3 
+                  DO ib = 1, ilen1(igrd)
+                     DO ik = 1, jpkm1
+                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                        dta_bdy(ib_bdy)%v3d(ib,ik) =  ( vn(ii,ij,ik) - pvn2d(ii,ij) ) * vmask(ii,ij,ik)         
+                        END DO
+                  END DO 
+               END IF
+            ENDIF
+
+            IF( nn_tra_dta(ib_bdy) .eq. 0 ) THEN 
+               ilen1(:) = nblen(:)
+               IF( dta%ll_tem ) THEN
+                  igrd = 1 
+                  DO ib = 1, ilen1(igrd)
+                     DO ik = 1, jpkm1
+                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                        dta_bdy(ib_bdy)%tem(ib,ik) = tsn(ii,ij,ik,jp_tem) * tmask(ii,ij,ik)         
+                     END DO
+                  END DO 
+               END IF
+               IF( dta%ll_sal ) THEN
+                  igrd = 1 
+                  DO ib = 1, ilen1(igrd)
+                     DO ik = 1, jpkm1
+                        ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                        ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                        dta_bdy(ib_bdy)%sal(ib,ik) = tsn(ii,ij,ik,jp_sal) * tmask(ii,ij,ik)         
+                     END DO
+                  END DO 
+               END IF
+            ENDIF
+
+#if defined key_lim2
+            IF( nn_ice_lim2_dta(ib_bdy) .eq. 0 ) THEN 
+               ilen1(:) = nblen(:)
+               IF( dta%ll_frld ) THEN
+                  igrd = 1 
+                  DO ib = 1, ilen1(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     dta_bdy(ib_bdy)%frld(ib) = frld(ii,ij) * tmask(ii,ij,1)         
+                  END DO 
+               END IF
+               IF( dta%ll_hicif ) THEN
+                  igrd = 1 
+                  DO ib = 1, ilen1(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     dta_bdy(ib_bdy)%hicif(ib) = hicif(ii,ij) * tmask(ii,ij,1)         
+                  END DO 
+               END IF
+               IF( dta%ll_hsnif ) THEN
+                  igrd = 1 
+                  DO ib = 1, ilen1(igrd)
+                     ii = idx_bdy(ib_bdy)%nbi(ib,igrd)
+                     ij = idx_bdy(ib_bdy)%nbj(ib,igrd)
+                     dta_bdy(ib_bdy)%hsnif(ib) = hsnif(ii,ij) * tmask(ii,ij,1)         
+                  END DO 
+               END IF
             ENDIF
 #endif
@@ -179,5 +217,5 @@
          ENDDO ! ib_bdy
 
-         CALL wrk_dealloc(jpi,jpj,pu2d,pv2d) 
+         CALL wrk_dealloc(jpi,jpj,pun2d,pvn2d) 
 
       ENDIF ! kt .eq. nit000
@@ -188,4 +226,5 @@
       jstart = 1
       DO ib_bdy = 1, nb_bdy   
+         dta => dta_bdy(ib_bdy)
          IF( nn_dta(ib_bdy) .eq. 1 ) THEN ! skip this bit if no external data required
       
@@ -193,22 +232,18 @@
                ! Update barotropic boundary conditions only
                ! jit is optional argument for fld_read and bdytide_update
-               IF( nn_dyn2d(ib_bdy) .gt. 0 ) THEN
+               IF( cn_dyn2d(ib_bdy) /= 'none' ) THEN
                   IF( nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
-                     dta_bdy(ib_bdy)%ssh(:) = 0.0
-                     dta_bdy(ib_bdy)%u2d(:) = 0.0
-                     dta_bdy(ib_bdy)%v2d(:) = 0.0
+                     IF( dta%ll_ssh ) dta%ssh(:) = 0.0
+                     IF( dta%ll_u2d ) dta%u2d(:) = 0.0
+                     IF( dta%ll_u3d ) dta%v2d(:) = 0.0
                   ENDIF
-                  IF (nn_tra(ib_bdy).ne.4) THEN
-                     IF( nn_dyn2d_dta(ib_bdy) .EQ. 1 .OR. nn_dyn2d_dta(ib_bdy) .EQ. 3 .OR.  &
-                       & (ln_full_vel_array(ib_bdy) .AND. nn_dyn3d_dta(ib_bdy).eq.1) )THEN
-
-                        ! For the runoff case, no need to update the forcing (already done in the baroclinic part)
-                        jend = nb_bdy_fld(ib_bdy)
-                        IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend - 2
+                  IF (cn_tra(ib_bdy) /= 'runoff') THEN
+                     IF( nn_dyn2d_dta(ib_bdy) .EQ. 1 .OR. nn_dyn2d_dta(ib_bdy) .EQ. 3 ) THEN
+
+                        jend = jstart + dta%nread(2) - 1
                         CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), map=nbmap_ptr(jstart:jend),  &
                                      & kit=jit, kt_offset=time_offset )
-                        IF ( nn_tra(ib_bdy) .GT. 0 .AND. nn_tra_dta(ib_bdy) .GE. 1 ) jend = jend + 2
-
-                        ! If full velocities in boundary data then split into barotropic and baroclinic data
+
+                        ! If full velocities in boundary data then extract barotropic velocities from 3D fields
                         IF( ln_full_vel_array(ib_bdy) .AND.                                             &
                           &    ( nn_dyn2d_dta(ib_bdy) .EQ. 1 .OR. nn_dyn2d_dta(ib_bdy) .EQ. 3 .OR.  &
@@ -216,35 +251,29 @@
 
                            igrd = 2                      ! zonal velocity
-                           dta_bdy(ib_bdy)%u2d(:) = 0.0
+                           dta%u2d(:) = 0.0
                            DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
                               ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                               ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
                               DO ik = 1, jpkm1
-                                 dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
-                       &                          + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
+                                 dta%u2d(ib) = dta%u2d(ib) &
+                       &                          + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta%u3d(ib,ik)
                               END DO
-                              dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
-                              DO ik = 1, jpkm1
-                                 dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib)
-                              END DO
+                              dta%u2d(ib) =  dta%u2d(ib) * hur(ii,ij)
                            END DO
                            igrd = 3                      ! meridional velocity
-                           dta_bdy(ib_bdy)%v2d(:) = 0.0
+                           dta%v2d(:) = 0.0
                            DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
                               ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                               ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
                               DO ik = 1, jpkm1
-                                 dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
-                       &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
+                                 dta%v2d(ib) = dta%v2d(ib) &
+                       &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta%v3d(ib,ik)
                               END DO
-                              dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
-                              DO ik = 1, jpkm1
-                                 dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib)
-                              END DO
+                              dta%v2d(ib) =  dta%v2d(ib) * hvr(ii,ij)
                            END DO
                         ENDIF                    
                      ENDIF
                      IF( nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                        CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy), td=tides(ib_bdy),   & 
+                        CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta, td=tides(ib_bdy),   & 
                           &                 jit=jit, time_offset=time_offset )
                      ENDIF
@@ -252,5 +281,5 @@
                ENDIF
             ELSE
-               IF (nn_tra(ib_bdy).eq.4) then      ! runoff condition
+               IF (cn_tra(ib_bdy) == 'runoff') then      ! runoff condition
                   jend = nb_bdy_fld(ib_bdy)
                   CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend),  &
@@ -261,5 +290,5 @@
                      ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                      ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) / ( e2u(ii,ij) * hu_0(ii,ij) )
+                     dta%u2d(ib) = dta%u2d(ib) / ( e2u(ii,ij) * hu_0(ii,ij) )
                   END DO
                   !
@@ -268,14 +297,14 @@
                      ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                      ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
-                     dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) / ( e1v(ii,ij) * hv_0(ii,ij) )
+                     dta%v2d(ib) = dta%v2d(ib) / ( e1v(ii,ij) * hv_0(ii,ij) )
                   END DO
                ELSE
-                  IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
-                     dta_bdy(ib_bdy)%ssh(:) = 0.0
-                     dta_bdy(ib_bdy)%u2d(:) = 0.0
-                     dta_bdy(ib_bdy)%v2d(:) = 0.0
+                  IF( nn_dyn2d_dta(ib_bdy) .eq. 2 ) THEN ! tidal harmonic forcing ONLY: initialise arrays
+                     IF( dta%ll_ssh ) dta%ssh(:) = 0.0
+                     IF( dta%ll_u2d ) dta%u2d(:) = 0.0
+                     IF( dta%ll_v2d ) dta%v2d(:) = 0.0
                   ENDIF
-                  IF( nb_bdy_fld(ib_bdy) .gt. 0 ) THEN ! update external data
-                     jend = nb_bdy_fld(ib_bdy)
+                  IF( dta%nread(1) .gt. 0 ) THEN ! update external data
+                     jend = jstart + dta%nread(1) - 1
                      CALL fld_read( kt=kt, kn_fsbc=1, sd=bf(jstart:jend), &
                                   & map=nbmap_ptr(jstart:jend), kt_offset=time_offset )
@@ -286,39 +315,39 @@
                     &   nn_dyn3d_dta(ib_bdy) .EQ. 1 ) ) THEN
                      igrd = 2                      ! zonal velocity
-                     dta_bdy(ib_bdy)%u2d(:) = 0.0
+                     dta%u2d(:) = 0.0
                      DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
                         ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                         ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
                         DO ik = 1, jpkm1
-                           dta_bdy(ib_bdy)%u2d(ib) = dta_bdy(ib_bdy)%u2d(ib) &
-                 &                       + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta_bdy(ib_bdy)%u3d(ib,ik)
+                           dta%u2d(ib) = dta%u2d(ib) &
+                 &                       + fse3u(ii,ij,ik) * umask(ii,ij,ik) * dta%u3d(ib,ik)
                         END DO
-                        dta_bdy(ib_bdy)%u2d(ib) =  dta_bdy(ib_bdy)%u2d(ib) * hur(ii,ij)
+                        dta%u2d(ib) =  dta%u2d(ib) * hur(ii,ij)
                         DO ik = 1, jpkm1
-                           dta_bdy(ib_bdy)%u3d(ib,ik) = dta_bdy(ib_bdy)%u3d(ib,ik) - dta_bdy(ib_bdy)%u2d(ib)
+                           dta%u3d(ib,ik) = dta%u3d(ib,ik) - dta%u2d(ib)
                         END DO
                      END DO
                      igrd = 3                      ! meridional velocity
-                     dta_bdy(ib_bdy)%v2d(:) = 0.0
+                     dta%v2d(:) = 0.0
                      DO ib = 1, idx_bdy(ib_bdy)%nblen(igrd)
                         ii   = idx_bdy(ib_bdy)%nbi(ib,igrd)
                         ij   = idx_bdy(ib_bdy)%nbj(ib,igrd)
                         DO ik = 1, jpkm1
-                           dta_bdy(ib_bdy)%v2d(ib) = dta_bdy(ib_bdy)%v2d(ib) &
-                 &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta_bdy(ib_bdy)%v3d(ib,ik)
+                           dta%v2d(ib) = dta%v2d(ib) &
+                 &                       + fse3v(ii,ij,ik) * vmask(ii,ij,ik) * dta%v3d(ib,ik)
                         END DO
-                        dta_bdy(ib_bdy)%v2d(ib) =  dta_bdy(ib_bdy)%v2d(ib) * hvr(ii,ij)
+                        dta%v2d(ib) =  dta%v2d(ib) * hvr(ii,ij)
                         DO ik = 1, jpkm1
-                           dta_bdy(ib_bdy)%v3d(ib,ik) = dta_bdy(ib_bdy)%v3d(ib,ik) - dta_bdy(ib_bdy)%v2d(ib)
+                           dta%v3d(ib,ik) = dta%v3d(ib,ik) - dta%v2d(ib)
                         END DO
                      END DO
                   ENDIF
-                  IF( nn_dyn2d(ib_bdy) .gt. 0 .and. nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
-                     CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta_bdy(ib_bdy),  &
+                  IF( cn_dyn2d(ib_bdy) /= 'none' .and. nn_dyn2d_dta(ib_bdy) .ge. 2 ) THEN ! update tidal harmonic forcing
+                     CALL bdytide_update( kt=kt, idx=idx_bdy(ib_bdy), dta=dta,  &
                                         & td=tides(ib_bdy), time_offset=time_offset )
                   ENDIF
                ENDIF
             ENDIF
-            jstart = jend+1
+            jstart = jstart + dta%nread(1)
          END IF ! nn_dta(ib_bdy) = 1
       END DO  ! ib_bdy
@@ -326,5 +355,5 @@
       IF ( ln_apr_obc ) THEN
          DO ib_bdy = 1, nb_bdy
-            IF (nn_tra(ib_bdy).NE.4)THEN
+            IF (cn_tra(ib_bdy) /= 'runoff')THEN
                igrd = 1                      ! meridional velocity
                DO ib = 1, idx_bdy(ib_bdy)%nblenrim(igrd)
@@ -349,5 +378,5 @@
       !!                for open boundary conditions
       !!
-      !! ** Method  :   Use fldread.F90
+      !! ** Method  :   
       !!                
       !!----------------------------------------------------------------------
@@ -361,9 +390,9 @@
                                                                 ! =F => baroclinic velocities in 3D boundary data
       INTEGER                                ::   ilen_global   ! Max length required for global bdy dta arrays
-      INTEGER,              DIMENSION(jpbgrd) ::  ilen0         ! size of local arrays
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   ilen1, ilen3  ! size of 1st and 3rd dimensions of local arrays
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   ibdy           ! bdy set for a particular jfld
       INTEGER, ALLOCATABLE, DIMENSION(:)     ::   igrid         ! index for grid type (1,2,3 = T,U,V)
       INTEGER, POINTER, DIMENSION(:)         ::   nblen, nblenrim  ! short cuts
+      TYPE(OBC_DATA), POINTER                ::   dta           ! short cut
       TYPE(FLD_N), ALLOCATABLE, DIMENSION(:) ::   blf_i         !  array of namelist information structures
       TYPE(FLD_N) ::   bn_tem, bn_sal, bn_u3d, bn_v3d   ! 
@@ -403,15 +432,15 @@
       nb_bdy_fld(:) = 0
       DO ib_bdy = 1, nb_bdy         
-         IF( nn_dyn2d(ib_bdy) .gt. 0 .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) THEN
+         IF( cn_dyn2d(ib_bdy) /= 'none' .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) THEN
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 3
          ENDIF
-         IF( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 1 ) THEN
+         IF( cn_dyn3d(ib_bdy) /= 'none' .and. nn_dyn3d_dta(ib_bdy) .eq. 1 ) THEN
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 2
          ENDIF
-         IF( nn_tra(ib_bdy) .gt. 0 .and. nn_tra_dta(ib_bdy) .eq. 1  ) THEN
+         IF( cn_tra(ib_bdy) /= 'none' .and. nn_tra_dta(ib_bdy) .eq. 1  ) THEN
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 2
          ENDIF
 #if defined key_lim2
-         IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 1  ) THEN
+         IF( cn_ice_lim2(ib_bdy) /= 'none' .and. nn_ice_lim2_dta(ib_bdy) .eq. 1  ) THEN
             nb_bdy_fld(ib_bdy) = nb_bdy_fld(ib_bdy) + 3
          ENDIF
@@ -471,10 +500,13 @@
             nblen => idx_bdy(ib_bdy)%nblen
             nblenrim => idx_bdy(ib_bdy)%nblenrim
+            dta => dta_bdy(ib_bdy)
+            dta%nread(2) = 0
 
             ! Only read in necessary fields for this set.
             ! Important that barotropic variables come first.
-            IF( nn_dyn2d(ib_bdy) .gt. 0 .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) THEN 
-
-               IF( nn_dyn2d(ib_bdy) .ne. jp_frs .and. nn_tra(ib_bdy) .ne. 4 ) THEN ! runoff condition : no ssh reading
+            IF( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) THEN 
+
+               IF( dta%ll_ssh ) THEN 
+                  if(lwp) write(numout,*) '++++++ reading in ssh field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_ssh
@@ -483,7 +515,9 @@
                   ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
-               ENDIF
-
-               IF( .not. ln_full_vel_array(ib_bdy) ) THEN
+                  dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+               IF( dta%ll_u2d .and. .not. ln_full_vel_array(ib_bdy) ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in u2d field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_u2d
@@ -492,5 +526,9 @@
                   ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
-
+                  dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+               IF( dta%ll_v2d .and. .not. ln_full_vel_array(ib_bdy) ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in v2d field'
                   jfld = jfld + 1
                   blf_i(jfld) = bn_v2d
@@ -499,45 +537,60 @@
                   ilen1(jfld) = nblen(igrid(jfld))
                   ilen3(jfld) = 1
-               ENDIF
-
-            ENDIF
-
-            ! baroclinic velocities
-            IF( ( nn_dyn3d(ib_bdy) .gt. 0 .and. nn_dyn3d_dta(ib_bdy) .eq. 1 ) .or. &
-           &      ( ln_full_vel_array(ib_bdy) .and. nn_dyn2d(ib_bdy) .gt. 0 .and.  &
-           &        ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) ) THEN
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_u3d
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 2
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_v3d
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 3
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
+                  dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+            ENDIF
+
+            ! read 3D velocities if baroclinic velocities require OR if
+            ! barotropic velocities required and ln_full_vel set to .true.
+            IF( nn_dyn3d_dta(ib_bdy) .eq. 1 .or. &
+           &  ( ln_full_vel_array(ib_bdy) .and. ( nn_dyn2d_dta(ib_bdy) .eq. 1 .or. nn_dyn2d_dta(ib_bdy) .eq. 3 ) ) ) THEN
+
+               IF( dta%ll_u3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in u3d field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_u3d
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 2
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+                  IF( ln_full_vel_array(ib_bdy) .and. dta%ll_u2d ) dta%nread(2) = dta%nread(2) + 1
+               ENDIF
+
+               IF( dta%ll_v3d .or. ( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in v3d field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_v3d
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 3
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+                  IF( ln_full_vel_array(ib_bdy) .and. dta%ll_v2d ) dta%nread(2) = dta%nread(2) + 1
+               ENDIF
 
             ENDIF
 
             ! temperature and salinity
-            IF( nn_tra(ib_bdy) .gt. 0 .and. nn_tra_dta(ib_bdy) .eq. 1 ) THEN
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_tem
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_sal
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = jpk
+            IF( nn_tra_dta(ib_bdy) .eq. 1 ) THEN
+
+               IF( dta%ll_tem ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in tem field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_tem
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+               ENDIF
+
+               IF( dta%ll_sal ) THEN
+                  if(lwp) write(numout,*) '++++++ reading in sal field'
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_sal
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = jpk
+               ENDIF
 
             ENDIF
@@ -545,26 +598,32 @@
 #if defined key_lim2
             ! sea ice
-            IF( nn_ice_lim2(ib_bdy) .gt. 0 .and. nn_ice_lim2_dta(ib_bdy) .eq. 1 ) THEN
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_frld
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = 1
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_hicif
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = 1
-
-               jfld = jfld + 1
-               blf_i(jfld) = bn_hsnif
-               ibdy(jfld) = ib_bdy
-               igrid(jfld) = 1
-               ilen1(jfld) = nblen(igrid(jfld))
-               ilen3(jfld) = 1
+            IF( nn_ice_lim2_dta(ib_bdy) .eq. 1 ) THEN
+
+               IF( dta%ll_frld ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_frld
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = 1
+               ENDIF
+
+               IF( dta%ll_hicif ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_hicif
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = 1
+               ENDIF
+
+               IF( dta%ll_hsnif ) THEN
+                  jfld = jfld + 1
+                  blf_i(jfld) = bn_hsnif
+                  ibdy(jfld) = ib_bdy
+                  igrid(jfld) = 1
+                  ilen1(jfld) = nblen(igrid(jfld))
+                  ilen3(jfld) = 1
+               ENDIF
 
             ENDIF
@@ -581,4 +640,6 @@
             ENDIF
 
+            dta%nread(1) = nb_bdy_fld(ib_bdy)
+
          ENDIF ! nn_dta .eq. 1
       ENDDO ! ib_bdy
